import { defineComponent as F, ref as E, watch as I, onMounted as N, onUnmounted as L, openBlock as r, createElementBlock as d, renderSlot as w, createElementVNode as V, createVNode as G, withCtx as h, Fragment as o, renderList as y, unref as n, toDisplayString as M, createBlock as f, createCommentVNode as v } from "vue";
import S from "./SidebarElement.vue.js";
import g from "./SidebarGroup.vue.js";
import { useNavState as D } from "../../hooks/useNavState.js";
import { useSidebar as H } from "../../hooks/useSidebar.js";
import { sleep as C } from "../../helpers/sleep.js";
const R = { class: "sidebar" }, U = ["aria-label"], j = { class: "sidebar-group-title" }, q = -160, W = /* @__PURE__ */ F({
  __name: "Sidebar",
  props: {
    parsedSpec: {},
    tagsSorter: { type: [String, Function] },
    operationsSorter: { type: [String, Function] }
  },
  setup(A) {
    const m = A, { hash: p, isIntersectionEnabled: $ } = D(), { items: O, toggleCollapsedSidebarItem: T, collapsedSidebarItems: _ } = H(
      {
        parsedSpec: m.parsedSpec,
        tagsSorter: m.tagsSorter,
        operationsSorter: m.operationsSorter
      }
    ), b = E(null), u = E(!0);
    I(p, (l) => {
      !$.value || u.value || typeof window > "u" || k(l);
    });
    const k = (l) => {
      var e, t, s, a;
      const i = document.getElementById(`sidebar-${l}`);
      if (!i || !b.value)
        return;
      let c = q;
      i.getAttribute("data-sidebar-type") === "heading" ? c += i.offsetTop + ((e = i.getElementsByClassName("sidebar-heading")) == null ? void 0 : e[0]).offsetHeight : c += i.offsetTop + (((t = i.parentElement) == null ? void 0 : t.offsetTop) ?? 0) + (((a = (s = i.parentElement) == null ? void 0 : s.parentElement) == null ? void 0 : a.offsetTop) ?? 0), b.value.scrollTo({ top: c, behavior: "smooth" });
    }, B = (l) => {
      if (!b.value)
        return;
      const i = new MutationObserver((c, e) => {
        document.getElementById(`sidebar-${l}`) && (k(l), u.value = !1, e.disconnect());
      });
      return i.observe(b.value, {
        childList: !0,
        subtree: !0
      }), i;
    };
    return N(() => {
      const l = B(p.value);
      L(() => {
        l == null || l.disconnect();
      });
    }), (l, i) => {
      var c;
      return r(), d("div", R, [
        w(l.$slots, "sidebar-start", {}, void 0, !0),
        V("nav", {
          ref_key: "scrollerEl",
          ref: b,
          "aria-label": `Table of contents for ${(c = l.parsedSpec.info) == null ? void 0 : c.title}`,
          class: "sidebar-pages custom-scroll custom-scroll-self-contain-overflow"
        }, [
          G(g, { level: 0 }, {
            default: h(() => [
              (r(!0), d(o, null, y(n(O).entries, (e) => (r(), d(o, {
                key: e.id
              }, [
                e.isGroup ? (r(), d(o, { key: 0 }, [
                  V("li", j, M(e.displayTitle ?? e.title), 1),
                  (r(!0), d(o, null, y(e.children, (t) => (r(), f(S, {
                    key: t.id,
                    id: `sidebar-${t.id}`,
                    "data-sidebar-type": "heading",
                    hasChildren: t.children && t.children.length > 0,
                    isActive: n(p) === t.id,
                    item: {
                      id: t.id,
                      title: t.displayTitle ?? t.title,
                      select: t.select,
                      httpVerb: t.httpVerb,
                      deprecated: t.deprecated ?? !1
                    },
                    open: n(_)[t.id] ?? !1,
                    onToggleOpen: async () => {
                      u.value = !0, n(T)(t.id), await n(C)(100), u.value = !1;
                    }
                  }, {
                    default: h(() => {
                      var s;
                      return [
                        t.children && ((s = t.children) == null ? void 0 : s.length) > 0 ? (r(), f(g, {
                          key: 0,
                          level: 1
                        }, {
                          default: h(() => [
                            (r(!0), d(o, null, y(t.children, (a) => (r(), d(o, {
                              key: a.id
                            }, [
                              e.show ? (r(), f(S, {
                                key: 0,
                                id: `sidebar-${a.id}`,
                                isActive: n(p) === a.id,
                                item: {
                                  id: a.id,
                                  title: a.displayTitle ?? a.title,
                                  select: a.select,
                                  httpVerb: a.httpVerb,
                                  deprecated: a.deprecated ?? !1
                                }
                              }, null, 8, ["id", "isActive", "item"])) : v("", !0)
                            ], 64))), 128))
                          ]),
                          _: 2
                        }, 1024)) : v("", !0)
                      ];
                    }),
                    _: 2
                  }, 1032, ["id", "hasChildren", "isActive", "item", "open", "onToggleOpen"]))), 128))
                ], 64)) : (r(), d(o, { key: 1 }, [
                  e.show ? (r(), f(S, {
                    key: 0,
                    id: `sidebar-${e.id}`,
                    "data-sidebar-type": "heading",
                    hasChildren: e.children && e.children.length > 0,
                    isActive: n(p) === e.id,
                    item: {
                      id: e.id,
                      title: e.displayTitle ?? e.title,
                      select: e.select,
                      httpVerb: e.httpVerb,
                      deprecated: e.deprecated ?? !1
                    },
                    open: n(_)[e.id] ?? !1,
                    onToggleOpen: async () => {
                      u.value = !0, n(T)(e.id), await n(C)(100), u.value = !1;
                    }
                  }, {
                    default: h(() => {
                      var t;
                      return [
                        e.children && ((t = e.children) == null ? void 0 : t.length) > 0 ? (r(), f(g, {
                          key: 0,
                          level: 1
                        }, {
                          default: h(() => [
                            (r(!0), d(o, null, y(e.children, (s) => (r(), d(o, {
                              key: s.id
                            }, [
                              e.show ? (r(), f(S, {
                                key: 0,
                                id: `sidebar-${s.id}`,
                                isActive: n(p) === s.id,
                                item: {
                                  id: s.id,
                                  title: s.displayTitle ?? s.title,
                                  select: s.select,
                                  httpVerb: s.httpVerb,
                                  deprecated: s.deprecated ?? !1
                                }
                              }, null, 8, ["id", "isActive", "item"])) : v("", !0)
                            ], 64))), 128))
                          ]),
                          _: 2
                        }, 1024)) : v("", !0)
                      ];
                    }),
                    _: 2
                  }, 1032, ["id", "hasChildren", "isActive", "item", "open", "onToggleOpen"])) : v("", !0)
                ], 64))
              ], 64))), 128))
            ]),
            _: 1
          })
        ], 8, U),
        w(l.$slots, "sidebar-end", {}, void 0, !0)
      ]);
    };
  }
});
export {
  W as default
};
