import { defineComponent as G, useId as L, computed as c, ref as T, watch as Q, unref as l, openBlock as d, createBlock as k, withCtx as r, createVNode as a, createElementBlock as b, Fragment as B, createTextVNode as f, toDisplayString as h, createElementVNode as E, renderSlot as K, createCommentVNode as C } from "vue";
import { useWorkspace as X } from "@scalar/api-client/store";
import { getSnippet as Y } from "@scalar/api-client/views/Components/CodeSnippet";
import { filterSecurityRequirements as Z } from "@scalar/api-client/views/Request/RequestSection";
import { ScalarCodeBlock as _ } from "@scalar/components";
import S from "../../components/ScreenReader.vue.js";
import { freezeElement as ee } from "../../helpers/freeze-element.js";
import { useConfig as te } from "../../hooks/useConfig.js";
import oe from "./ExamplePicker.vue.js";
import le from "./TextSelect.vue.js";
/* empty css                */
import V from "../../components/Card/Card.vue.js";
import re from "../../components/Card/CardHeader.vue.js";
import j from "../../components/HttpMethod/HttpMethod.vue.js";
import H from "../../components/Card/CardContent.vue.js";
import ae from "../../components/Card/CardFooter.vue.js";
import { useExampleStore as ne } from "../../legacy/stores/useExampleStore.js";
import { useHttpClientStore as se } from "../../stores/useHttpClientStore.js";
const ie = ["id"], ue = ["id"], me = {
  key: 0,
  class: "request-card-footer-addon"
}, ce = { class: "request-header" }, Te = /* @__PURE__ */ G({
  __name: "ExampleRequest",
  props: {
    operation: {},
    server: {},
    collection: {},
    fallback: { type: Boolean },
    transformedOperation: {}
  },
  setup(n) {
    const { selectedExampleKey: R, operationId: w } = ne(), { requestExamples: J, securitySchemes: q } = X(), I = te(), {
      httpClient: i,
      setHttpClient: U,
      availableTargets: $,
      httpTargetTitle: z,
      httpClientTitle: F
    } = se(), y = L(), m = c(() => {
      var t;
      const e = ["x-custom-examples", "x-codeSamples", "x-code-samples"];
      for (const o of e)
        if ((t = n.transformedOperation.information) != null && t[o])
          return [...n.transformedOperation.information[o]];
      return [];
    }), s = T(
      // Default to first custom example
      m.value.length ? {
        targetKey: "customExamples",
        clientKey: 0
      } : (
        // Otherwise use the globally selected HTTP client
        {
          targetKey: i.targetKey,
          clientKey: i.clientKey
        }
      )
    );
    Q(i, () => {
      s.value = {
        targetKey: i.targetKey,
        clientKey: i.clientKey
      };
    });
    const O = c(
      () => {
        var e, t, o, u;
        return Object.keys(
          ((u = (o = (t = (e = n.transformedOperation.information) == null ? void 0 : e.requestBody) == null ? void 0 : t.content) == null ? void 0 : o["application/json"]) == null ? void 0 : u.examples) ?? {}
        ).length > 1;
      }
    ), M = () => {
      var g;
      if (s.value.targetKey === "customExamples")
        return ((g = m.value[s.value.clientKey]) == null ? void 0 : g.source) ?? "";
      const e = i.clientKey, t = i.targetKey, o = J[n.operation.examples[0]];
      if (!o)
        return "";
      const u = Z(
        n.operation.security || n.collection.security,
        n.collection.selectedSecuritySchemeUids,
        q
      ), [p, v] = Y(t, e, {
        operation: n.operation,
        example: o,
        server: n.server,
        securitySchemes: u
      });
      return p ? p.message ?? "" : v;
    }, N = c(() => {
      try {
        return M();
      } catch (e) {
        return console.error("[generateSnippet]", e), "";
      }
    }), P = c(() => {
      var t, o;
      const e = (
        // Specified language
        ((t = s.value) == null ? void 0 : t.targetKey) === "customExamples" ? ((o = m.value[s.value.clientKey]) == null ? void 0 : o.lang) ?? "plaintext" : (
          // Or language for the globally selected HTTP client
          i.targetKey
        )
      );
      return e === "shell" && N.value.includes("curl") ? "curl" : e === "Objective-C" ? "objc" : e;
    }), D = c(
      () => Object.values(q).flatMap((e) => e.type === "apiKey" ? e.value : (e == null ? void 0 : e.type) === "http" ? [
        e.token,
        e.password,
        btoa(`${e.username}:${e.password}`)
      ] : e.type === "oauth2" ? Object.values(e.flows).map((t) => t.token) : [])
    ), W = c(() => {
      const e = $.value.map((t) => ({
        value: t.key,
        label: t.title,
        options: t.clients.map((o) => ({
          value: JSON.stringify({
            targetKey: t.key,
            clientKey: o.client
          }),
          label: o.title
        }))
      }));
      return m.value.length && e.unshift({
        value: "customExamples",
        label: "Examples",
        options: m.value.map((t, o) => ({
          value: JSON.stringify({
            targetKey: "customExamples",
            clientKey: o
          }),
          label: t.label ?? t.lang ?? `Example #${o + 1}`
        }))
      }), e;
    }), x = T(null);
    function A(e) {
      const t = JSON.parse(e);
      if (x.value) {
        const o = ee(x.value.$el);
        setTimeout(() => {
          o();
        }, 300);
      }
      t.targetKey === "customExamples" ? s.value = t : U(t);
    }
    return (e, t) => l($).length || m.value.length ? (d(), k(l(V), {
      key: 0,
      "aria-labelledby": `${l(y)}-header`,
      class: "dark-mode",
      ref_key: "elem",
      ref: x,
      role: "region"
    }, {
      default: r(() => [
        a(l(re), { muted: "" }, {
          actions: r(() => [
            a(le, {
              class: "request-client-picker",
              controls: `${l(y)}-example`,
              modelValue: JSON.stringify(s.value),
              options: W.value,
              "onUpdate:modelValue": A
            }, {
              default: r(() => [
                s.value.targetKey === "customExamples" ? (d(), b(B, { key: 0 }, [
                  a(S, null, {
                    default: r(() => t[2] || (t[2] = [
                      f("Selected Example:")
                    ])),
                    _: 1
                  }),
                  f(" " + h(m.value[s.value.clientKey].label ?? "Example"), 1)
                ], 64)) : (d(), b(B, { key: 1 }, [
                  a(S, null, {
                    default: r(() => t[3] || (t[3] = [
                      f("Selected HTTP client:")
                    ])),
                    _: 1
                  }),
                  f(" " + h(l(z)) + " " + h(l(F)), 1)
                ], 64))
              ]),
              _: 1
            }, 8, ["controls", "modelValue", "options"])
          ]),
          default: r(() => [
            E("div", {
              id: `${l(y)}-header`,
              class: "request-header"
            }, [
              a(S, null, {
                default: r(() => t[1] || (t[1] = [
                  f("Request Example for")
                ])),
                _: 1
              }),
              a(l(j), {
                as: "span",
                class: "request-method",
                method: e.operation.method
              }, null, 8, ["method"]),
              K(e.$slots, "header", {}, void 0, !0)
            ], 8, ie)
          ]),
          _: 3
        }),
        a(l(H), {
          borderless: "",
          class: "request-editor-section custom-scroll",
          frameless: ""
        }, {
          default: r(() => [
            E("div", {
              id: `${l(y)}-example`,
              class: "code-snippet"
            }, [
              a(l(_), {
                class: "bg-b-2 -outline-offset-2",
                content: N.value,
                hideCredentials: D.value,
                lang: P.value,
                lineNumbers: ""
              }, null, 8, ["content", "hideCredentials", "lang"])
            ], 8, ue)
          ]),
          _: 1
        }),
        (O.value || !l(I).hideTestRequestButton) && e.$slots.footer ? (d(), k(l(ae), {
          key: 0,
          class: "request-card-footer",
          contrast: ""
        }, {
          default: r(() => {
            var o, u, p, v;
            return [
              O.value ? (d(), b("div", me, [
                a(oe, {
                  class: "request-example-selector",
                  examples: ((v = (p = (u = (o = e.transformedOperation.information) == null ? void 0 : o.requestBody) == null ? void 0 : u.content) == null ? void 0 : p["application/json"]) == null ? void 0 : v.examples) ?? [],
                  "onUpdate:modelValue": t[0] || (t[0] = (g) => (R.value = g, w.value = e.operation.operationId))
                }, null, 8, ["examples"])
              ])) : C("", !0),
              K(e.$slots, "footer", {}, void 0, !0)
            ];
          }),
          _: 3
        })) : C("", !0)
      ]),
      _: 3
    }, 8, ["aria-labelledby"])) : e.fallback ? (d(), k(l(V), {
      key: 1,
      class: "dark-mode"
    }, {
      default: r(() => [
        a(l(H), { class: "request-card-simple" }, {
          default: r(() => [
            E("div", ce, [
              a(l(j), {
                as: "span",
                class: "request-method",
                method: e.operation.method
              }, null, 8, ["method"]),
              K(e.$slots, "header", {}, void 0, !0)
            ]),
            K(e.$slots, "footer", {}, void 0, !0)
          ]),
          _: 3
        })
      ]),
      _: 3
    })) : C("", !0);
  }
});
export {
  Te as default
};
